/* 	PLUGIN SDAL_ANTI_WEAPON
	WRITTEN BY: [WING] Sir Drink a lot
	visit www.adminmod.de
	
	DESCRIPTION: 	You can sanction a weapon and reduce players hp,
			if he uses the weapon nevertheless.

	COMMANDS:	
	admin_aw_slap 'nr.'			= slaps player x-times, if he uses the weapon
	admin_aw_weapon 'menu1' 'menu2' 'weapon'= sanctions the weapon (the name of the weapon must be written correctly!!!)
	admin_aw_display 			= weapon sanction is displayed to all players again
	
	CHAT:
	You can type 'weapon' in chat to see, which weapon is sanctioned.
	
	VAULT.INI SETTINGS:
	AW_SLAP			'value'
	AW_MAINMENU		'value'
	AW_MENUSELECT		'value'
	AW_WEAPON		'cs-weapon-name'
	
	WARNING:
	The weapon name must correspond to the cs-weapon name. Otherwise it would not be detected correcly.
	
	-- CHANGELOG --
	
	09.01.03:	First release
	
*/
		

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new String_Version[]="08.01.03";

#define ACCESS_CONSOLE 131072

/*
*********** PLUGIN EINSTELLUNGEN AUS DER VAULT.INI ***********
SLAPX 		= 	Definiere in vault.ini, wieviel HP von 100HP abgezogen wird. 
		  	Default => 10 * 5 = 50 HP.
MENU & SELECT 	= 	Definiere in vault.ini, welches Men mit welcher Auswahl 
		 	bestraft wird.
Weapon		= 	Definiere in vault.ini den Namen der Waffe
			(entspricht dem Menu und Select)
			!!WAFFENNAME MUSS DER CS-DEFINITION entsprechen!!
			Waffennamen:
			Pistolen:	DEAGLE,GLOCK,USP,ELITE,FIVESEVEN,P228
			Shotguns:	M3,XM1014
			SMGs:		MP5,P90,TMP,MAC,UMP40
			Rifles:		AUG,SG552,AWP,M4A1,AK47,SCOUT,SG550,G3SG1	
			MG:		M249
*/
new SLAPX;
new MENU;
new SELECT;
new Weapon[MAX_TEXT_LENGTH];
/*****************************************************************
*/


new Flag[MAX_PLAYERS]=1;
new Buy[MAX_PLAYERS];
new BuyMenu[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("Anti Weapon Plugin","Reduces hp when using a sanctioned weapon.",String_Version);
	plugin_registercmd("admin_aw_display","admin_aw_display",ACCESS_MAP,"admin_aw_display : weapon sanction is displayed to all players");
	plugin_registercmd("admin_aw_slap","admin_aw_slap",ACCESS_MAP,"admin_aw_slap 'x': slaps player 'x' * 5hp, when using the weapon");
	plugin_registercmd("admin_aw_weapon","admin_aw_weapon",ACCESS_MAP,"admin_aw_weapon 'menu1' 'menu2' 'weapon': restricts weapon using the menu numbers.");
	plugin_registercmd("buy","buy",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("say","SayCommand",ACCESS_ALL,"say 'weapon': to look for a sanctioned weapon.");
	plugin_registercmd("anti_weapon_world", "anti_weapon_world", ACCESS_CONSOLE);
	plugin_registercmd("anti_weapon_detect", "anti_weapon_detect", ACCESS_CONSOLE);
	exec( "logd_reg 62 admin_command anti_weapon_world" );	/*WORLD-ACTION*/
	exec( "logd_reg 58 admin_command anti_weapon_detect" );	/*INJURE-EVENT*/
	
	/*vault.ini Eintraege sammeln*/
	get_vaultnumdata("AW_SLAP",SLAPX);
	get_vaultnumdata("AW_MAINMENU",MENU);
	get_vaultnumdata("AW_MENUSELECT",SELECT);
	get_vaultdata("AW_WEAPON",Weapon,MAX_TEXT_LENGTH);
	
	if(SLAPX == 0 || MENU == 0 || SELECT == 0){
		SLAPX=0;
		selfmessage("[PLUGIN ANTI_WEAPON] Plugin is disabled. Please read manuell!");
	} 
	
	return PLUGIN_CONTINUE;
}

public admin_aw_display(HLCommand, HLData, HLUserName, UserIndex){
	display_all(0);
	return PLUGIN_HANDLED;
}

public admin_aw_slap(HLCommand, HLData, HLUserName, UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iData;
	new x;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iData = strtonum(Data);
	SLAPX = iData;
	set_vaultnumdata("AW_SLAP",SLAPX);
	x=SLAPX*5;
	if(x>95){
		x=95;
	}
	
	if(SLAPX==0){
		snprintf(Text,MAX_TEXT_LENGTH,"Slap Value is set to 0. Plugin is disabled.");
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Slap Value is set to %i. Sanction: %i HP.",SLAPX,x);
	}
	display_console(Text);
	display_all(0);	
	return PLUGIN_HANDLED;
}

public admin_aw_weapon(HLCommand, HLData, HLUserName, UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new sMenu[MAX_NUMBER_LENGTH];
	new sSelect[MAX_NUMBER_LENGTH];
			
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	strsplit(Data," ",sMenu,MAX_NUMBER_LENGTH,sSelect,MAX_NUMBER_LENGTH,Weapon,MAX_TEXT_LENGTH);
	
	MENU = strtonum(sMenu);
	SELECT = strtonum(sSelect);
	set_vaultnumdata("AW_MAINMENU",MENU);
	set_vaultnumdata("AW_MENUSELECT",SELECT);
	set_vaultdata("AW_WEAPON",Weapon);
	
	if(MENU==0){
		snprintf(Text,MAX_TEXT_LENGTH,"Menu is 0. Plugin is disabled. Please read manuell");
		SLAPX=0;
	}else if(SELECT==0){
		snprintf(Text,MAX_TEXT_LENGTH,"Select is 0. Plugin is disabled. Please read manuell");
		SLAPX=0;
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"'Menu' is set to %i and 'Select' to %i. Weapon restricted: %s", MENU, SELECT, Weapon);
	}
	display_console(Text);
	display_all(0);	
	return PLUGIN_HANDLED;
}

public buy(HLCommand, HLData, HLUserName, UserIndex){
	if(SLAPX>0){
		Buy[UserIndex]=1;
	}
	return PLUGIN_CONTINUE;
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(SLAPX>0){
		new Data[MAX_DATA_LENGTH];
		new Player[MAX_NAME_LENGTH];
		new iData;
	  	convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,Player,MAX_NAME_LENGTH);
		if(Buy[UserIndex]==1){
			iData=strtonum(Data);
			if(BuyMenu[UserIndex]==MENU && iData == SELECT && Flag[UserIndex]==1){
				reset_buy(UserIndex);
				Flag[UserIndex]=3;
				retribution(Player);
			}else if(iData==MENU){
				BuyMenu[UserIndex]=MENU;
			}else{
				reset_buy(UserIndex);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_command(HLCommand, HLData, HLUserName, UserIndex){
	if(SLAPX>0){
		new Player[MAX_NAME_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new WeaponDef[MAX_TEXT_LENGTH]="weapon_";
		
		convert_string(HLUserName,Player,MAX_NAME_LENGTH);
		convert_string(HLCommand,Data,MAX_DATA_LENGTH);
		if(strncmp(Data,WeaponDef,7)==0){
			strcat(WeaponDef,Weapon,MAX_TEXT_LENGTH);
			if(strcasecmp(Data,WeaponDef)==0){
				if(Flag[UserIndex]==1){
					Flag[UserIndex]=2;
					retribution(Player);
				}else if(Flag[UserIndex]==3){
					Flag[UserIndex]=2;
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	reset_player(UserIndex);
	display_consgreet();
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	reset_player(UserIndex);
	return PLUGIN_CONTINUE;
}

public SayCommand(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
  	strstripquotes(Data);
  	if (strcasecmp(Data,"weapon")==0) {
  		display_all(1);
	}
	return PLUGIN_CONTINUE;
}

/*LogD-Functions*/

/*World-Event*/
public anti_weapon_world(HLCommand, HLData, HLUserName, UserIndex){
	if(SLAPX>0){
		new Data[MAX_DATA_LENGTH];
		new Player[MAX_NAME_LENGTH];
		new Authid[MAX_AUTHID_LENGTH];
		new SID,WID,Team,Dead;
		new i;
		new maxplayers=maxplayercount();
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		
		if(Data[8]=='R' || Data[0]=='G'){
			reset_all();
		}else if(Data[6]=='S') {
			reset_all();
			/*
			Dann checken wir mal, was der Player fr eine Waffe hat.
			Wenn er nicht schon durch das 'buy' abgefangen wurde, kriegen wir
			ihn jetzt. Allersptestens, wenn er die Waffe auswhlt!
			*/
			for(i=1;i<=maxplayers;i++){
				if(Flag[i]==1){
					if(playerinfo(i,Player,MAX_NAME_LENGTH,SID,WID,Team,Dead,Authid)){
						if(strcmp(Authid,"BOT")!=0 && Dead != 1){
							execclient(Player,"slot10");
							set_timer("exec_client",1,0,Player);
						}
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

/*Injure+Kill-Event*/
public anti_weapon_detect(HLCommand, HLData, HLUserName, UserIndex){
	if(SLAPX>0){
		new Data[MAX_DATA_LENGTH];
		new sAtt[3];
		new sVic[3];
		new sweapon[MAX_TEXT_LENGTH];
		new iAID;
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		strsplit(Data," ",sAtt,3,sVic,3,sweapon,MAX_TEXT_LENGTH);
		iAID=strtonum(sAtt);
		if(strcasecmp(sweapon,Weapon)==0){
			attacker_detection(iAID);
		}
	}
	return PLUGIN_CONTINUE;
}

/*Helper-Functions*/

attacker_detection(iAttackerID){
	new Player[MAX_NAME_LENGTH];
	new Authid[MAX_AUTHID_LENGTH];
	new SID,WID,Team,Dead;
	if(playerinfo(iAttackerID,Player,MAX_NAME_LENGTH,SID,WID,Team,Dead,Authid)){
		if(strcmp(Authid,"BOT")!=0 && Dead !=1){
			if(Flag[iAttackerID]==1){
				Flag[iAttackerID]=2;
				retribution(Player);
			}else if(Flag[iAttackerID]==3){
				Flag[iAttackerID]=2;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

display_all(iMode){
	new Text[MAX_TEXT_LENGTH];
	new x;
	x=SLAPX*5;
	if(x>95){
		x=95;
	}
	if(SLAPX>0){
		snprintf(Text,MAX_TEXT_LENGTH,"Folgende Waffe ist sanktioniert:^n '%s' ^n Eine Benutzung wird mit Abzug von^n '%i HP'^n bestraft!",Weapon,x);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Alle Waffen sind^n ohne Einschraenkung erlaubt!!!");
	}
	if(iMode==0){
		centersay(Text,12,255,0,0);
	}
	say(Text);
	return PLUGIN_CONTINUE;
}

display_console(Text[]){
	selfmessage("");
	selfmessage("--- PLUGIN SDAL-ANTI-WEAPON ---");
	selfmessage("");
	selfmessage(Text);
	selfmessage("");
	selfmessage("-------------------------------");
	return PLUGIN_CONTINUE;
}

display_consgreet(){
	new Text[MAX_TEXT_LENGTH];
	new x;
	x=SLAPX*5;
	if(x>95){
		x=95;
	}
	consgreet("");
	consgreet("********* PLUGIN SDAL-ANTI-WEAPON ************");
	consgreet("> Sanktionierung von Waffen:");
	consgreet(">");
	if(SLAPX>0){
		
		snprintf(Text,MAX_TEXT_LENGTH,"> Spieler, die ein(e) %s benutzen,",Weapon);
		consgreet(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"> bekommen %i HP Abzug im Spiel!",x);
		consgreet(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"> Also benutzt die Waffe besser nicht!");
		consgreet(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"> Es sind zur Zeit alle Waffen ohne");
		consgreet(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"> Einschraenkung erlaubt!");
		consgreet(Text);
	}
	snprintf(Text,MAX_TEXT_LENGTH,"> Mit der Chat-Eingabe 'weapon' kann der");
	consgreet(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"> momentane Status nochmal angezeigt werden.");
	consgreet(Text);
	consgreet(">");
	consgreet("**********************************************************");
	return PLUGIN_CONTINUE;
}

public exec_client(Timer,Repeat,HLName,HLParam) {
	if(SLAPX>0){
		new Player[MAX_NAME_LENGTH];
		convert_string(HLParam,Player,MAX_NAME_LENGTH);
		execclient(Player, "slot1");
	}
	return PLUGIN_CONTINUE;
}

reset_all(){
	/*Lschen der Flags der AWP-Trger, um sie erneut zu berprfen*/
	new i;
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		if(Flag[i]==2){
			Flag[i]=1;
		}
	}
	return PLUGIN_HANDLED;
}
reset_buy(UserIndex){
	Buy[UserIndex]=0;
	BuyMenu[UserIndex]=0;
	return PLUGIN_HANDLED;
}

reset_player(UserIndex){
	Flag[UserIndex]=1;
	Buy[UserIndex]=0;
	BuyMenu[UserIndex]=0;
	return PLUGIN_HANDLED;
}

retribution(Target[]){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new x;
	x=SLAPX*5;
	if(x>95){
		x=95;
	}
	snprintf(Text,MAX_TEXT_LENGTH,"Wer mit %s spielt,^n bekommt %i HP Abzug!",Weapon,x);
	messageex(Target,Text,print_tty);
	messageex(Target,Text,print_chat);
	for(i=0;i<SLAPX;i++){
		slap(Target);
	}
	return PLUGIN_HANDLED;
}